/**************************************************************************/
/*                                                                        */
/*      USE THE LONGITUDINAL FILE FOR 1996                                */
/*      TO CALCULATE THE AVERAGE NUMBER OF CONSULTATION OF A DOCTOR       */
/*      BY WOMEN, ACCORDING TO THEIR LIVING STATUS (SINGLE PARENT OR      */
/*      LIVING INTO A RELATIONSHIP, WITH CHILDREN).                       */
/*                                                                        */
/**************************************************************************/

libname in1 'c:\data';

data long;
  %let datafid="c:\data\dumylngf.txt";
  %include "c:\data\lngf_in.sas";
  keep realukey personid dhc4dlvg dhc6dlvg dhc6decf dhc4decf dhc6gage sex 
       mhc6dds hcc6_2a hcc6_2c wt66lf;
  run;

data in1.long;
  set long;
  if sex=2;              /* keep females only                                         */
  if dhc6gage >= 5;      /* keep only 12 years old and older                          */
  if dhc4decf in (5,9);  /* keep those in a couple with kids under 25 and no others
                            or single parents with kids under 25 and no others (1994) */
  if dhc6decf in (5,9);  /* keep those in a couple with kids under 25 and no others
                            or single parents with kids under 25 and no others (1996) */
  if dhc4dlvg in (4,5);  /* must be in a couple or single with kids and no others (1994)*/
  if dhc6dlvg in (4,5);  /* must be in a couple or single with kids and no others (1996)*/


  /* living status */

  if dhc4dlvg=4 and dhc6dlvg=4 then living='long-term couple';
  else if (dhc4dlvg=4 or dhc4dlvg=5) and dhc6dlvg=5 then living='single parent   ';
  else delete;


  /* # consultation to doctors in 1996 */;

  if hcc6_2a < 996 and hcc6_2c < 996 then doc=sum(hcc6_2a, hcc6_2c);
  else delete;
  run;
