*                                    AVERTISSEMENT

* Le gouvernement du Canada (Statistique Canada) possde tous les droits de proprit
* intellectuelle (y compris le droit d'auteur) relatifs  ce logiciel.  Sous rserve
* des modalits dcrites ci-dessous, vous obtenez une licence non exclusive et non
* transmissible d'utilisation de ce logiciel.
*
* Ce logiciel vous est fourni  tel quel , et le titulaire ne donne aucune garantie
* expresse ou implicite, ce qui comprend les garanties de qualit marchande et de
* convenance  une fin particulire mais ne se limite pas  ces garanties.  En aucune
* circonstance le titulaire ne sera responsable de dommages indirects, particuliers ou
* conscutifs, ou d'autres dommages semblables.  Ce contrat sera automatiquement rsili,
* sans pravis, si vous omettez de respecter une quelconque des modalits du contrat.;

/*******************************************************************/
/* Date: 1er dcembre 1997                                         */
/* Modifi: 30 octobre 1998                                        */
/*******************************************************************/

/*********************************************************************************/
/***                                                                           ***/
/***                        Programme SAS BOOTVAR                              ***/
/***                                                                           ***/
/*** Ce programme calcule des estimations de variance pour diffrents types    ***/
/*** d'estimations  l'aide des poids bootstrap.   l'aide de macros SAS,      ***/
/*** ce programme peut calculer des estimations de variance pour des totaux,   ***/
/*** des rapports, et des diffrences de rapports.  Il peut aussi calculer des ***/
/*** estimations de variance pour des paramtres de rgressions linaires,     ***/
/*** logistiques ou d'un modle linaire gnralis.  Ce programme peut aussi  ***/
/*** tre modifi pour s'adapter  d'autres types d'analyse.                   ***/
/***                                                                           ***/
/*** Ce programme est divis en 4 sections, dcrites plus bas.  Tout au long   ***/
/*** du programme, les changements que l'utilisateur doit apporter sont indi-  ***/
/*** qus.                                                                     ***/
/***                                                                           ***/
/*** Section 1: Dclaration des variables macros                               ***/
/***            C'est  cet endroit qu'on dfinit les variables qui seront     ***/
/***            utilises tout au long du programme.  Certains changements     ***/
/***            doivent tre apports par l'utilisateur.                       ***/
/*** Section 2: Dclaration des macros                                         ***/
/***            C'est  cet endroit qu'est dfinie la portion du programme qui ***/
/***            calcule les estimations de variance.  Aucun changement n'est   ***/
/***            requis de la part de l'utilisateur dans cette section ( l'ex- ***/
/***            ception de la macro pour un modle linaire gnralis (REGGLM). */
/***            Cette macro doit tre modifie selon les besoins de            ***/
/***            l'utilisateur).                                                ***/
/*** Section 3: Programme principal                                            ***/
/***            C'est  cet endroit qu'on lit les fichiers contenant les       ***/
/***            variables  analyser et les poids bootstrap.  Les variables    ***/
/***             utiliser dans les analyses doivent tre dfinies par l'utili-***/
/***            sateur avant d'utiliser ce programme.                          ***/
/*** Section 4: noncs pour soumettre les macros                              ***/
/***            C'est  cet endroit que l'utilisateur doit indiqu quelle(s)   ***/
/***            macro(s) il/elle dsire soumettre.   ce stade, l'utilisateur  ***/
/***            peut soumettre une macro une fois, une macro plusieurs fois,   ***/
/***            ou plusieurs macros.  tant donn le grand nombre d'observa-   ***/
/***            tions  analyser, il est recommand de limiter le              ***/
/***            nombre de macros qui sont soumises, en particulier dans le cas ***/
/***            de rgressions.                                                ***/
/***                                                                           ***/
/*** Avant d'utiliser ce programme, l'utilisateur doit prparer un fichier     ***/
/*** d'analyse qui contiendra les variables  analyser.  Ce fichier ne devrait ***/
/*** contenir que les enregistrements pour lesquels l'analyse est ncessaire   ***/
/*** (p.e. si l'analyse est faite pour le groupe d'ge 12 ans et plus, seuls   ***/
/*** les enregistrements des individus de 12 ans et plus devraient tre inclus ***/
/*** dans le fichier).  Une variable appele REGION doit aussi tre cre si   ***/
/*** les analyses sont faites  un niveau rgional.  Par exemple, si l'analyse ***/
/*** est faite au niveau provincial, la variable REGION prendra la mme valeur ***/
/*** que la variable qui contient la province sur le fichier de microdonnes   ***/
/*** (p.e. PRC6_CUR).  Si l'analyse est faite au niveau des rgions de sant,  ***/
/*** la variable REGION prendra la valeur de la rgion de sant pour chaque    ***/
/*** enregistrement.                                                           ***/
/***                                                                           ***/
/*** N.B. Pour calculer un total, un rapport, ou une diffrence entre deux     ***/
/*** rapports, les estimations sont obtenues en sommant le poids des enregis-  ***/
/*** trements qui ont la caractristique d'intrt.  Donc, une variable indi-  ***/
/*** catrice doit tre cre pour chaque variable  analyser.  Elle prendra la ***/
/*** valeur 1 lorsque l'enregistrement a la caractristique d'intrt et 0     ***/
/*** sinon.                                                                    ***/
/*********************************************************************************/

options ps=48 ls=120 ;


/*********************************************************************************/
/*** Section 1: Dclaration des variables macros                               ***/
/*********************************************************************************/

%let R=01;                         /* paramtre du bootstrap moyen (fixe) */

/*****************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOMBRE DE POIDS BOOTSTRAP  UTILISER,  ***/
/*** DIVIS PAR 100                                                        ***/
/*** %let B=1;	pour le fichier de poids bootstrap B1H35                   ***/
/*** %let B=5;	pour les fichiers de poids bootstrap bd5H356, bd5H356A,    ***/
/***            bd5H356C, bd5LONGF et bd5LONGP                             ***/
/*****************************************************************************/

%let B=5;                     /* nombre de poids bootstrap Bx100 */


/************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE RPERTOIRE CONTENANT LE FICHIER   ***/
/*** D'ANALYSE (in1) ET LE FICHIER CONTENANT LES POIDS BOOTSTRAP      ***/
/*** (in2).  LES FICHIERS DE SORTIES SERONT SAUVEGARDS DANS LE       ***/
/*** RPERTOIRE SPCIFI POUR in3.                                    ***/
/************************************************************************/

libname in1 "c:\data";
libname in2 "c:\bootstrp";
libname in3 "c:\output";


/*********************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOM DU FICHIER SAS CONTENANT LES VARIABLES ***/
/*** D'ANALYSE.                                                                ***/
/*** %let Mfile=xxx;                                                           ***/
/*********************************************************************************/

%let Mfile=in1.h356;                          /* Nom du fichier SAS principal */


/*********************************************************************************/
/*** L'UTILISATEUR DOIT INDIQUER LE NOM DU FICHIER SAS CONTENANT LES POIDS     ***/
/*** BOOTSTRAP.                                                                ***/
/*** SI LA VERSION SAS DU FICHIER N'EXISTE PAS ENCORE, IL FAUT LE CRER.       ***/
/*** %let bsamp=bd5h35;   ( utiliser avec le fichier H35.TXT)    OU           ***/
/*** %let bsamp=bd5h356;  ( utiliser avec le fichier H356.TXT)   OU           ***/
/*** %let bsamp=bd5h356a; ( utiliser avec le fichier H356.TXT)   OU           ***/
/*** %let bsamp=bd5h356c; ( utiliser avec le fichier H356.TXT)   OU           ***/
/*** %let bsamp=bd5longf; ( utiliser avec le fichier LONGF.TXT)               ***/
/*** %let bsamp=bd5longp; ( utiliser avec le fichier LONGP.TXT)               ***/
/*********************************************************************************/

data in2.bd5h356;
  %let datafid="c:\bootstrp\bd5h356.txt";
  %include "c:\bootstrp\boot_in.sas";

%let bsamp=in2.bd5h356;               /* fichier SAS des poids bootstrap */


/*****************************************************************/
/*** L'UTILISATEUR DOIT SPCIFIER LA VALEUR DES PARAMTRES by, ***/
/*** wo ET kp.  CEUX-CI INDIQUENT SI L'ANALYSE EST FAITE AU    ***/
/*** NIVEAU RGIONAL OU POUR L'ENSEMBLE DU FICHIER.            ***/
/***                                                           ***/
/*** SI L'ANALYSE EST FAITE POUR L'ENSEMBLE DU FICHIER, ALORS  ***/
/***    %let by=*;                                             ***/
/***    %let wo=;                                              ***/
/***    %let kp=;                                              ***/
/***                                                           ***/
/*** SINON, SI L'ANALYSE EST FAITE AU NIVEAU RGIONAL, ALORS   ***/
/***    %let by=;                                              ***/
/***    %let wo=*;                                             ***/
/***    %let kp=region;                                        ***/
/*****************************************************************/

%let by=*;
%let wo=;
%let kp=;


data time;
  format start datetime16.;
  start=datetime();
  output;
run;


/*********************************************************************************/
/*** Section 2: Dclaration des macros                                         ***/
/*********************************************************************************/

%let printtot=0;
%let printdif=0;
%let printreg=0;
%let printlog=0;

%global dep;

*************************************;

%macro total(infile,var,bssz=,multi=);

*************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var;
&by  by region;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

data est;
  set ytot;
  length var1 $ 8;
  length var2 $ 8;
  length type $ 8;
  bs_var=&multi*((&bssz-1)*(var(of ybs1-ybs&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=round((bs_sd/yhat)*100,.01);
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var";
  var2="Aucune";
  type="Total";
  drop ybs1-ybs&bssz _type_ _freq_;
run;

proc append data=est base=alltots;
run;

%let printtot=1;

%mend total;


*******************************************;

%macro ratio(infile,var1,var2,bssz=,multi=);

*******************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var1;
&by  by region;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var2;
&by  by region;
  output out=xtot
         sum=xhat xbs1-xbs&bssz;
run;

data est;
  merge ytot xtot;
  array ybs{&bssz};
  array xbs{&bssz};
  array rbs{&bssz};
  length var1 $ 8;
  length var2 $ 8;
  length type $ 8;
  yhat=((yhat/xhat)*100);
  do i=1 to &bssz;
    rbs{i}=((ybs{i}/xbs{i})*100);
  end;
  bs_var=&multi*((&bssz-1)*(var(of rbs1-rbs&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=round((bs_sd/yhat)*100,.01);
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var1";
  var2="&var2";
  type="Rapport";
  drop ybs1-ybs&bssz xbs1-xbs&bssz rbs1-rbs&bssz xhat i _type_ _freq_;
run;

proc append data=est base=alltots;
run;

%let printtot=1;

%mend ratio;


********************************************************;

%macro diff_rat(infile,var1,var2,var3,var4,bssz=,multi=);

********************************************************;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var1;
&by  by region;
  output out=ytot
         sum=yhat ybs1-ybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var2;
&by  by region;
  output out=xtot
         sum=xhat xbs1-xbs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var3;
&by  by region;
  output out=yytot
         sum=yyhat yybs1-yybs&bssz;
run;

proc means data=&infile noprint;
  var fwgt bsw1-bsw&bssz;
  weight &var4;
&by  by region;
  output out=xxtot
         sum=xxhat xxbs1-xxbs&bssz;
run;

data est;
  merge ytot xtot yytot xxtot;
  array ybs{&bssz};
  array xbs{&bssz};
  array yybs{&bssz};
  array xxbs{&bssz};
  array drbs{&bssz};
  length var1 $ 8;
  length var2 $ 8;
  length var3 $ 8;
  length var4 $ 8;
  length type $ 10;
  yhat=(((yhat/xhat)-(yyhat/xxhat))*100);
  do i=1 to &bssz;
    drbs{i}=(((ybs{i}/xbs{i})-(yybs{i}/xxbs{i}))*100);
  end;
  bs_var=(&multi*((&bssz-1)*(var(of drbs1-drbs&bssz)))/&bssz);
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/yhat)*100,.01));
  cil95=yhat-1.96*bs_sd;
  ciu95=yhat+1.96*bs_sd;
  var1="&var1";
  var2="&var2";
  var3="&var3";
  var4="&var4";
  type="Diff_Rapport";
  drop ybs1-ybs&bssz xbs1-xbs&bssz yybs1-yybs&bssz xxbs1-xxbs&bssz drbs1-drbs&bssz
       xhat xxhat yyhat i _type_ _freq_;
run;

proc append data=est base=diffrat;
run;

%let printdif=1;

%mend diff_rat;


*********************************************;

%macro regress(infile,yvar,xvar,bssz=,multi=);

*********************************************;

proc reg data=&infile outest=orig(keep=&kp intercep &xvar) noprint;
  model &yvar=&xvar;
  weight fwgt;
&by  by region;
run;

proc transpose data=orig out=origest(drop=_label_) prefix=bhat name=beta;
  var intercep &xvar;
&by  by region;
run;

%let L=%eval(&bssz/10);

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

  data poids;
    set &infile;
    keep bsw&j-bsw&kL &yvar &xvar &kp;
  run;

  %do i=&j %to &kL;

   proc reg data=poids outest=betas(keep=&kp intercep &xvar) noprint;
     model &yvar=&xvar;
     weight bsw&i;
&by  by region;
   run;

   proc transpose data=betas out=betat prefix=best name=beta;
     var intercep &xvar;
&by  by region;
   run;

   data betat;
     set betat;
     drop _label_;
     rename best1=best&i;
   run;

   %if (&i =1) %then %do;

     data bsbeta;
       set betat;
     run;

   %end;
   %else %do;

     data bsbeta;
       merge bsbeta betat;
&by    by region;
     run;

   %end;
  %end;
%end;

data est;
  merge origest bsbeta;
  rename bhat1=bhat;
  bs_var=&multi*((&bssz-1)*(var(of best1-best&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/bhat1)*100,.01));
  cil95=bhat1-1.96*bs_sd;
  ciu95=bhat1+1.96*bs_sd;
  ydep="&yvar";
  drop best1-best&bssz;
run;

proc append data=est base=bs_reg;
run;

%let printreg=1;
%let dep=&yvar;

%mend regress;


*********************************************;

%macro logreg(infile,yvar,xvar,bssz=,multi=);

*********************************************;
proc logistic data=&infile outest=orig(keep=&kp intercep &xvar) descending noprint;
  model &yvar=&xvar;
  &by by region;
  weight fwgt;
run;

proc transpose data=orig out=origest prefix=bhat name=beta;
  var intercep &xvar;
  &by by region;
run;

%let L=%eval(&bssz/10);

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

  data poids;
    set &infile;
    keep bsw&j-bsw&kL &yvar &xvar &kp;
  run;

  %do i=&j %to &kL;

    proc logistic data=poids outest=betas(keep=&kp intercep &xvar) noprint descending;
      model &yvar=&xvar;
      &by by region;
      weight bsw&i;
    run;

    proc transpose data=betas out=betat prefix=best name=beta;
      var intercep &xvar;
      &by by region;
    run;

    data betat;
      set betat;
      rename best1=best&i;
    run;

    %if (&i =1) %then %do;

      data bsbeta;
        set betat;
      run;

    %end;
    %else %do;

      data bsbeta;
        merge bsbeta betat;
        &by by region;
      run;

    %end;
  %end;
%end;

data est;
  merge origest bsbeta;
  rename bhat1=bhat;
  bs_var=&multi*((&bssz-1)*(var(of best1-best&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/bhat1)*100,.01));
  wald=(bhat1/bs_sd)*(bhat1/bs_sd);
  pvalue=1-probchi(wald,1);
  lo95=bhat1-1.96*bs_sd;
  hi95=bhat1+1.96*bs_sd;
  odds=exp(bhat1);
  cil95=exp(lo95);
  ciu95=exp(hi95);
  ydep="&yvar";
  drop best1-best&bssz;
run;

proc append data=est base=bs_reglg;
run;

%let printlog=1;
%let dep=&yvar;

%mend logreg;


********************************************;

%macro regglm(infile,yvar,xvar,bssz=,multi=);

********************************************;
proc glm data=&infile noprint;
     class &xvar;
     model &yvar= &xvar;
     LSMEANS &xvar / out=orig;
     weight fwgt;
&by  by region;
run;

data orig2;
  set orig;
  drop _name_ stderr;
  array meanss{3};
  do i=1 to 3;
    if _n_ = i then do;
      meanss(i)=lsmean;
      retain;
    end;
  end;

  if _n_=3 then do;
    diff1_2= meanss1-meanss2;
    diff1_3= meanss1-meanss3;
    diff2_3= meanss2-meanss3;
    drop  smc6_2 lsmean i meanss1- meanss3;
    output;
  end;
run;

proc transpose data=orig2 out=origest prefix=bhat name=beta;
var diff1_2 diff1_3 diff2_3;
run;

%let L=%eval(&bssz/10);

%do k=1 %to 10;
  %let j=%eval(1+((&k-1)*&L));
  %let kL=%eval(&k*&L);

  data poids;
    set &infile;
    keep bsw&j-bsw&kL &yvar &xvar &kp;
  run;

  %do i=&j %to &kL;

  proc glm data=poids noprint;
    class &xvar;
    model &yvar= &xvar;
    LSMEANS &xvar / out=betas;
    weight bsw&i;
    &by by region;
  run;

  data betas2;
    set betas;
    drop _name_ stderr;
    array meanss{3};
    do i=1 to 3;
      if _n_ = i then do;
        meanss(i)=lsmean;
        retain;
      end;
    end;

    if _n_=3 then do;
      diff1_2= meanss1-meanss2;
      diff1_3= meanss1-meanss3;
      diff2_3= meanss2-meanss3;
      drop smc6_2 lsmean i meanss1- meanss3;
      output;
    end;
  run;

  proc transpose data=betas2 out=betat prefix=best name=beta;
   var diff1_2 diff1_3 diff2_3;
  run;

   data betat;
    set betat;
    rename best1=best&i;
   run;

  %if (&i =1) %then %do;

    data bsbeta;
      set betat;
    run;

  %end;
  %else %do;

     data bsbeta;
       merge bsbeta betat;
       &by by region;
     run;

  %end;
 %end;
%end;

data est;
  merge origest bsbeta;
  rename bhat1=bhat;
  bs_var=&multi*((&bssz-1)*(var(of best1-best&bssz)))/&bssz;
  bs_sd=sqrt(bs_var);
  bs_cv=abs(round((bs_sd/bhat1)*100,.01));
  cil95=bhat1-2.39406*bs_sd;
  ciu95=bhat1+2.39406*bs_sd;
  drop best1-best&bssz;
run;

proc append data=est base=bs_reg;
run;

%let printreg=1;
%let dep=&yvar;

%mend regglm;


****************;

%macro prnttot;

****************;
%if &printtot=1 %then %do;

&by   proc sort data=alltots;
&by     by region;
&by   run;

/**************************************************/
/* Imprime les rsultats des macro total et ratio */
/**************************************************/

   proc print data=alltots;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Totaux et des Rapports";
     var &kp type var1 var2 yhat bs_sd bs_cv cil95 ciu95;
     format yhat bs_sd cil95 ciu95 11.2;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Total ou Rapport)***/
        /*** var1 et var2 : variables utilises pour calculer   ***/
        /***                les estimations.  Pour un total,    ***/
        /***                var2=Aucune.                        ***/
        /*** yhat         : estimation du paramtre (en % pour  ***/
        /***                un rapport)                         ***/
        /*** bs_sd        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** cil95        : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /*** ciu95        : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prnttot;

****************;

%macro prntdiff;

****************;
%if &printdif=1 %then %do;

&by   proc sort data=diffrat;
&by     by region;
&by   run;

/**********************************************/
/* Imprime les rsultats de la macro diff_rat */
/**********************************************/

   proc print data=diffrat;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Diffrences entre des Rapports";
     var &kp type var1 var2 var3 var4 yhat bs_sd bs_cv cil95 ciu95;
     format yhat bs_sd cil95 ciu95 11.2;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /*** type         : type d'estimation (Diff_Rapport)    ***/
        /*** var1,var2,                                         ***/
        /*** var3 et var4 : variables utilises pour calculer   ***/
        /***                l'estimation                        ***/
        /*** yhat         : estimation (diffrence en %)        ***/
        /*** bs_sd        : cart-type                          ***/
        /*** bs_cv        : coefficient de variation            ***/
        /*** cil95        : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /*** ciu95        : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/



%mend prntdiff;

****************;

%macro prntreg;

****************;
%if &printreg=1 %then %do;

/******************************************************/
/* Imprime les rsultats des macros regress et regglm */
/******************************************************/

   proc print data=bs_reg;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour une";
     title2 "Rgression";
     title3 "Variable dpendante: &dep";
     var &kp beta bhat bs_var bs_sd bs_cv cil95 ciu95;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   beta       : paramtre  estimer                 ***/
        /***   bhat       : estimation du paramtre             ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_sd      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de l'esti- ***/
        /***                mation du paramtre                 ***/
        /***   cil95      : borne infrieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /***   ciu95      : borne suprieure de l'intervalle de ***/
        /***                confiance  95%                     ***/
        /**********************************************************/


%mend prntreg;

****************;

%macro prntlog;

****************;
%if &printlog=1 %then %do;

/********************************************/
/* Imprime les rsultats de la macro logreg */
/********************************************/

   proc print data=bs_reglg;
     title "Estimation de la variance  l'aide du bootstrap &B.00:&R pour des";
     title2 "Rgressions logistiques";
     title3 "Variable dpendante: &dep";
     var &kp beta bhat odds wald pvalue bs_var bs_sd bs_cv cil95 ciu95;
   run;
%end;

        /**********************************************************/
        /*** O:                                                ***/
        /***   beta       : paramtre  estimer                 ***/
        /***   bhat       : estimation du paramtre             ***/
        /***   odds       : rapport de cotes                    ***/
        /***   wald       : statistique de Wald                 ***/
        /***   pvalue     : valeur p de la statistique de Wald  ***/
        /***   bsvar      : variance de l'estimation du paramtre */
        /***   bs_sd      : cart-type de l'estimation du       ***/
        /***                paramtre                           ***/
        /***   bs_cv      : coefficient de variation de         ***/
        /***                l'estimation du paramtre           ***/
        /***   cil95      : borne infrieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /***   ciu95      : borne suprieure de l'intervalle de ***/
        /***                confiance  95% du rapport de cotes ***/
        /**********************************************************/


%mend prntlog;


*********************************************************************;
*  Section 3: Programme principal                                   *;
*********************************************************************;

/* Lit le fichier principal */

/************************************************************************/
/***  CAUSE DU GRAND NOMBRE D'OBSERVATIONS, SEULES LES VARIABLES     ***/
/*** REQUISES POUR FAIRE LES ANALYSES ET LES VARIABLES                ***/
/*** "REALUKEY" ET "PERSONID" DEVRAIENT TRE CONSERVES DSORMAIS.    ***/
/************************************************************************/

   data nphs (index=(id=(realukey personid)));
     set &Mfile (keep= realukey personid + VARIABLES  ANALYSER);
   run;

/* Lit les poids bootstrap */
/* FWGT correspond  WT56, WT66, WT66_N, WT66LF ou WT66LP selon le fichier 
 analyser */

   data bsamp (index=(id=(realukey personid)));
     set &bsamp;
     keep fwgt realukey personid bsw1-bsw&B.00;
   run;


/* Apparie le fichier principal et les poids bootstrap */

&by data bs_nphs (index=(region));
&wo data bs_nphs;
      merge nphs (in=in1) bsamp (in=in2);
      by realukey personid;
      if in1;
    run;

   proc datasets library=work;
     delete nphs bsamp;
   run;


/*********************************************************************************/
/*** Section 4: noncs pour soumettre les macros                              ***/
/*********************************************************************************/

/**********************************************************************************/
/*** Les estimations de variance sont calcules  l'aide des macros SAS dfinies***/
/*** plus tt dans le programme.  Ces macros SAS peuvent tre soumises durant   ***/
/*** l'excution du programme, selon les besoins de l'utilisateur.  Pour        ***/
/*** soumettre une macro, il suffit de spcifier un nonc indiquant le nom de  ***/
/*** la macro  soumettre et les paramtres  utiliser.  Dans ce programme, les ***/
/*** paramtres indiquent quel fichier doit tre lu, quelles variables seront   ***/
/*** utilises, combien de poids bootstrap seront utiliss, et combien          ***/
/*** d'chantillons de bootstrap ont t choisis.  Le nom du fichier  lire est ***/
/*** toujours le mme (BS_NPHS) et les deux derniers paramtres ont dj t    ***/
/*** dfinis au dbut du programme.  L'utilisateur n'a donc qu' spcifier les  ***/
/*** variables  analyser.                                                      ***/
/***                                                                            ***/
/*** Chaque soumission d'une macro donnera une estimation de la variance d'un   ***/
/*** seul paramtre  estimer.  Si plus d'un paramtre et sa variance doivent   ***/
/*** tre calculs, il faut alors soumettre la macro  plusieurs reprises.      ***/
/***                                                                            ***/
/*** Un exemple d'un nonc pour soumettre une macro apparat dans le programme ***/
/***  l'endroit o l'utilisateur doit spcifier cet nonc.  L'exemple est mis ***/
/*** en commentaire dans le programme.  L'nonc utilis par l'utilisateur sera ***/
/*** identique  l'exemple,  l'exception des variables  analyser.             ***/
/**********************************************************************************/

/*********/
/*       */
/* Total */
/*       */
/*********/

   proc datasets library=work; /* initialise alltots */
     delete alltots;
   run;

/****************************************************************************/
/*** Pour soumettre la macro total, l'nonc suivant est utilis:         ***/
/*** %total(infile,var,bssz=,multi=);                                     ***/
/***       o    infile : bs_nphs                                         ***/
/***             var    : la variable pour laquelle un total doit tre    ***/
/***                      calcul                                         ***/
/***             bssz=  : bssz=&B.00                                      ***/
/***             multi= : multi=&R                                        ***/
/***                                                                      ***/
/****************************************************************************/

 *  %total(bs_nphs,VAR,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro total */

   proc datasets library=work;
     delete ytot est;
   run;


/***********/
/*         */
/* Rapport */
/*         */
/***********/

/******************************************************************************/
/*** Pour soumettre la macro ratio, l'nonc suivant est utilis:           ***/
/*** %ratio(infile,var1,var2,bssz=,multi=);                                 ***/
/***       o    infile : bs_nphs                                           ***/
/***             var1   : la variable au numrateur du rapport              ***/
/***             var2   : la variable au dnominateur du rapport            ***/
/***             bssz=  : bssz=&B.00                                        ***/
/***             multi= : multi=&R                                          ***/
/***                                                                        ***/
/******************************************************************************/


 *  %ratio(bs_nphs,VAR1,VAR2,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro ratio */
   proc datasets library=work;
     delete ytot xtot est;
   run;

%prnttot;

/**********************************************************/
/*** Les rsultats des macro total et ratio             ***/
/*** peuvent tre sauvegards dans un fichier permanent ***/
/**********************************************************/

*   data in3.ZZZ;
*     set alltots;
*   run;


/*********************************/
/*                               */
/* Diffrence entre des Rapports */
/*                               */
/*********************************/

   proc datasets library=work; /* initialise diffrat */
     delete diffrat;
   run;

/******************************************************************************/
/*** Pour soumettre la macro diff_rat, l'nonc suivant est utilis:        ***/
/*** %diff_rat(infile,var1,var2,var3,var4,bssz=,multi=);                    ***/
/***       o    infile : bs_nphs                                           ***/
/***             var1   : la variable au numrateur du 1er rapport          ***/
/***             var2   : la variable au dnominateur du 1er rapport        ***/
/***             var3   : la variable au numrateur du 2e rapport           ***/
/***             var4   : la variable au dnominateur du 2e rapport         ***/
/***             bssz=  : bssz=&B.00                                        ***/
/***             multi= : multi=&R                                          ***/
/***                                                                        ***/
/*** Nota: L'intervalle de confiance est calcul pour une analyse faisant   ***/
/*** une seule comparaison de rapports.  Si des comparaisons multiples sont ***/
/*** faites, la faon de calculer l'intervalle de confiance doit tenir      ***/
/*** compte de cette situation.  Pour cette raison, dans le cas de comparai-***/
/*** sons multiples, la valeur de la loi normale (Z) utilise dans le       ***/
/*** calcul de l'intervalle de confiance doit tre corrige  la section 2, ***/
/*** Dclaration des macros, en utilisant, par exemple, l'approche de       ***/
/*** Bonferroni pour les comparaisons multiples.                            ***/
/***                                                                        ***/
/******************************************************************************/


 *  %diff_rat(bs_nphs,VAR1,VAR2,VAR3,VAR4,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro diff_rat */
   proc datasets library=work;
     delete ytot xtot yytot xxtot est;
   run;

%prntdiff;

/**************************************************/
/*** Les rsultats de la macro diff_rat peuvent ***/
/*** tre sauvegards dans un fichier permanent ***/
/**************************************************/

*   data in3.ZZZ;
*     set diffrat;
*   run;


/**************/
/*            */
/* Rgression */
/*            */
/**************/

   proc datasets library=work; /* initialise bs_reg */
     delete bs_reg;
   run;

/*******************************************************************************/
/*** Pour soumettre la macro regress, l'nonc suivant est utilis:          ***/
/*** %regress(infile,yvar,xvar,bssz=,multi=);                                ***/
/***       o    infile : bs_nphs                                            ***/
/***             yvar   : la variable dpendante                             ***/
/***             xvar   : les variables indpendantes.  Les variables doivent***/
/***                      tre inscrites comme elles le seraient dans l'non-***/
/***                      c d'un modle (sans virgules entre elles).        ***/
/***             bssz=  : bssz=&B.00                                         ***/
/***             multi= : multi=&R                                           ***/
/***                                                                         ***/
/*******************************************************************************/


 *  %regress(bs_nphs,YVAR,XVAR,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro regress */
   proc datasets library=work;
     delete betas betat bsbeta origest;
   run;


/*************************/
/*                       */
/* Rgression Logistique */
/*                       */
/*************************/

   proc datasets library=work; /* initialise bs_reglg */
     delete bs_reglg;
   run;

/*******************************************************************************/
/*** Pour soumettre la macro logreg, l'nonc suivant est utilis:           ***/
/*** %logreg(infile,yvar,xvar,bssz=,multi=);                                 ***/
/***       o    infile : bs_nphs                                            ***/
/***             yvar   : la variable dpendante                             ***/
/***             xvar   : les variables indpendantes.  Les variables doivent***/
/***                      tre inscrites comme elles le seraient dans l'non-***/
/***                      c d'un modle (sans virgules entre elles).        ***/
/***             bssz=  : bssz=&B.00                                         ***/
/***             multi= : multi=&R                                           ***/
/***                                                                         ***/
/*******************************************************************************/


 *  %logreg(bs_nphs,YVAR,XVAR,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro logreg */
   proc datasets library=work;
     delete betas betat bsbeta origest;
   run;


/******************************/
/*                            */
/* Modle Linaire Gnralis */
/*                            */
/******************************/

/*******************************************************************************/
/*** N.B. La macro regglm doit tre modifie pour rpondre aux besoins de    ***/
/***      l'utilisateur.  La macro regglm dfinie dans ce programme est un   ***/
/***      exemple d'une analyse qui a t faite en utilisant ce programme.   ***/
/***                                                                         ***/
/*** Pour soumettre la macro regglm, l'nonc suivant est utilis:           ***/
/*** %regglm(infile,yvar,xvar,bssz=,multi=);                                 ***/
/***       o    infile : bs_nphs                                            ***/
/***             yvar   : la variable dpendante                             ***/
/***             xvar   : les variables indpendantes.  Les variable doivent ***/
/***                      tre inscrites comme elles le seraient dans l'non-***/
/***                      c d'un modle (sans virgules entre elles).        ***/
/***             bssz=  : bssz=&B.00                                         ***/
/***             multi= : multi=&R                                           ***/
/***                                                                         ***/
/*** Nota: Si la macro regglm est adapte pour calculer des diffrences entre **/
/***       des moyennes, la faon de calculer l'intervalle de confiance doit ***/
/***       tenir compte des comparaisons multiples.  La valeur de la loi     ***/
/***       normale (Z) utilise dans le calcul de l'intervalle de confiance  ***/
/***       doit tre corrige  la section 2, Dclaration des macros, en     ***/
/***       utilisant, par exemple, l'approche de Bonferroni pour les         ***/
/***       comparaisons multiples.                                           ***/
/***                                                                         ***/
/*******************************************************************************/

 *  %regglm(bs_nphs,YVAR,XVAR,bssz=&B.00,multi=&R);

/* Dtruit les fichiers SAS de la macro regglm */
   proc datasets library=work;
     delete betas betat bsbeta origest;
   run;

%prntreg;

/**********************************************************/
/*** Les rsultats des macros regress et regglm         ***/
/*** peuvent tre sauvegards dans un fichier permanent ***/
/**********************************************************/

*   data in3.ZZZ;
*     set bs_reg;
*   run;


%prntlog;

/**************************************************/
/*** Les rsultats de la macro logreg peuvent   ***/
/*** tre sauvegards dans un fichier permanent ***/
/**************************************************/

*   data in3.ZZZ;
*     set bs_reglg;
*   run;


data time;
  set time;
  format stop datetime16.;
  stop=datetime();
  output;
run;

proc print data=time;
  title 'Temps requis pour excuter le programme';
run;

/* Fin du programme SAS Bootvar */
