/**************************************************************************/
/*                                                                        */
/*      UTILISE LE FICHIER LONGITUDINAL POUR 1996                         */
/*      CALCULE LE NOMBRE MOYEN DE CONSULTATIONS AVEC UN MDECIN PAR      */
/*      LES FEMMES AYANT DES ENFANTS SELON LEUR ARRANGEMENT FAMILIAL      */
/*      (MONOPARENTAL OU VIVANT AVEC UN CONJOINT, AVEC ENFANTS)           */
/*                                                                        */
/**************************************************************************/

libname in1 'c:\data';

data long;
  %let datafid="c:\data\dumylngf.txt";
  %include "c:\data\lngf_in.sas";
  keep realukey personid dhc4dlvg dhc6dlvg dhc6decf dhc4decf dhc6gage 
       sex mhc6dds hcc6_2a hcc6_2c wt66lf;
  run;

data in1.long;
  set long;
  if sex=2;              /* femmes seulement                                         */
  if dhc6gage >= 5;      /* 12 ans et plus                                           */
  if dhc4decf in (5,9);  /* femmes vivant en couple avec enfants < 25 ans seulement
                              ou monoparental avec enfants < 25 and seulement (1994) */
  if dhc6decf in (5,9);  /* femmes vivant en couple avec enfants < 25 ans seulement
                              ou monoparental avec enfants < 25 and seulement (1996) */
  if dhc4dlvg in (4,5);  /*vivant en couple ou clibataire avec enfants seulement (1994)*/
  if dhc6dlvg in (4,5);  /*vivant en couple ou clibataire avec enfants seulement (1996)*/


  /* arrangement familial */

  if dhc4dlvg=4 and dhc6dlvg=4 then living='couple 94-96  ';
  else if (dhc4dlvg=4 or dhc4dlvg=5) and dhc6dlvg=5 then living='monoparental  ';
  else delete;


  /* nombre de consultations avec un mdecin, 1996 */

  if hcc6_2a < 996 and hcc6_2c < 996 then doc=sum(hcc6_2a, hcc6_2c);
  else delete;
  run;
